//============================================================
// Project				:	CityRPG
// Author				:	Iban & Jookia & Ty(ID997) (Edited by Gadgethm)
// Description			:	Civilian Code file
// ============================================================
// Table of Contents
// 1. Handling Script Start
// 2. Lots
// 2.2 Sale Lots
// 3. Data Bricks
// 4. Spawns
// 5. Resources
// 6. Other
// 7. Decals
// 8. Drugs
// ============================================================

// ============================================================
// Section 1 : Handling Script Start
// ============================================================
$CityRPG::temp::brickError = forceRequiredAddOn("player_no_jet");

if($CityRPG::temp::brickError)
{
	if($CityRPG::temp::brickError == $error::addOn_disabled)
		playerNoJet.uiName = "";
	
	if($CityRPG::temp::brickError == $error::addOn_notFound)
		return;
}

$CityRPG::loadedDatablocks = true;

if(!$CityRPG::loadedDatablocks)
{
	return;
}

datablock triggerData(CityRPGLotTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};

datablock triggerData(CityRPGInputTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};


// ============================================================
// Section 2 : Lots
// ============================================================
datablock fxDTSBrickData(CityRPGSmallLotBrickData : brick16x16FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x16LotIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Lots";
	
	uiName = "Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 16 4800";
	trigger = 0;
	
	initialPrice = 500;
	taxAmount = 10;
};

datablock fxDTSBrickData(CityRPGHalfSmallLotBrickData : brick16x32FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x32LotIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Lots";
	
	uiName = "Half-Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 32 4800";
	trigger = 0;
	
	initialPrice = 750;
	taxAmount = 15;
};

datablock fxDTSBrickData(CityRPGMediumLotBrickData : brick32x32FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/32x32LotIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Lots";
	
	uiName = "Medium Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "32 32 6400";
	trigger = 0;
	
	initialPrice = 1500;
	taxAmount = 25;
};

datablock fxDTSBrickData(CityRPGLargeLotBrickData : brick64x64FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/64x64LotIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Lots";
	
	uiName = "Large Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "64 64 12800";
	trigger = 0;
	
	initialPrice = 4500;
	taxAmount = 60;
};

// Sale Lots
datablock fxDTSBrickData(CityRPGSmallZoneBrickData : brick16x16FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x16ZoneIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Zones";
	
	uiName = "Small Zone";

	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGHalfSmallZoneBrickData : brick16x32FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x32ZoneIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Zones";
	
	uiName = "Half-Small Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGHalfSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGMediumZoneBrickData : brick32x32FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/32x32ZoneIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Zones";
	
	uiName = "Medium Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGMediumLotBrickData;
};

datablock fxDTSBrickData(CityRPGLargeZoneBrickData : brick64x64FData)
{
	iconName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/64x64ZoneIcon";
	
	category = "CityRPG";
	subCategory = "CityRPG Zones";
	
	uiName = "Large Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGLargeLotBrickData;
};
// ============================================================
// Section 3 : Data Bricks
// ============================================================
exec("./bricks/info/bank.cs");
exec("./bricks/info/police.cs");
exec("./bricks/info/bounty.cs");
exec("./bricks/info/labor.cs");
exec("./bricks/info/realestate.cs");
exec("./bricks/info/criminalbank.cs");
exec("./bricks/info/atm.cs");
exec("./bricks/info/playeratm.cs");
exec("./bricks/info/education.cs");
exec("./bricks/info/job.cs");
exec("./bricks/info/stats.cs");
exec("./bricks/info/drugsell.cs");
exec("./bricks/info/donate.cs");
exec("./bricks/info/family.cs");
exec("./bricks/info/vote.cs");
exec("./bricks/info/other.cs");
exec("./bricks/info/lottery.cs");
exec("./bricks/info/storage.cs");
exec("./bricks/info/business.cs");
exec("./bricks/info/gangs.cs");
exec("./bricks/info/LaborPlus.cs");

// ============================================================
// Section 4 : Spawns
// ============================================================
datablock fxDtsBrickData(CityRPGPersonalSpawnBrickData : brickSpawnPointData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	
	uiName = "Personal Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = false;
	
	spawnData = "personalSpawn";
};

datablock fxDtsBrickData(CityRPGJailSpawnBrickData : brickSpawnPointData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	
	uiName = "Jail Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = true;
	
	spawnData = "jailSpawn";
};

// ============================================================
// Section 5 : Resources
// ============================================================
exec("./bricks/resources/tree.cs");
exec("./bricks/resources/ore.cs");
exec("./bricks/resources/smallore.cs");

// ============================================================
// Section 6 : Other
// ============================================================
datablock fxDTSBrickData(CityRPGPermaSpawnData : brick2x2FData)
{
	category = "CityRPG";
	subCategory = "CityRPG Infoblock";
	
	uiName = "Permaspawn Brick";

	CityRPGBrickAdmin = true;
	CityRPGPermaspawn = 1;
};

datablock fxDTSBrickData(CityRPGPoliceVehicleData : brickVehicleSpawnData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	uiName = "Police Vehicle Spawn";
	CityRPGBrickAdmin = true;
};

datablock fxDTSBrickData(CityRPGCrimeVehicleData : brickVehicleSpawnData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	uiName = "Crime Vehicle Spawn";
	CityRPGBrickAdmin = true;
};

datablock fxDTSBrickData(CityRPGParaVehicleData : brickVehicleSpawnData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	uiName = "Paramedic Vehicle Spawn";
	CityRPGBrickAdmin = true;
};

DoorSO.addDoorTypeFromFile("Add-Ons/Gamemode_TysCityRPG/bricks/doors/unbreakable.cs");
doorBrickUnbreakable.unbreakable = true;
doorBrickUnbreakable.CityRPGBrickAdmin = true;

// ============================================================
// Section 7 : Decals
// ============================================================
datablock decalData(CityRPGLogo)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/decals/CityRPGLogo.Gad's";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_1)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x16LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_2)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x32LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_3)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/32x32LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_4)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/64x64LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_1)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x16ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_2)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/16x32ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_3)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/32x32ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_4)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/64x64ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Ore_Icon)
{
	textureName = "Add-Ons/Gamemode_TysCityRPG/shapes/BrickIcons/4x Cube";
	preload = true;
};

// ============================================================
// Section 8 : Drugs
// ============================================================
exec("./bricks/drugs/marijuana.cs");
exec("./bricks/drugs/opium.cs");
exec("./bricks/drugs/speed.cs");
exec("./bricks/drugs/steroid.cs");